## mrpt 2.1.7

=== CMakeLists.txt ===
﻿# ----------------------------------------------------------------------------
# Root CMake file for the MRPT libraries and applications
#
#  Run with "cmake ." at the root directory to build the makefiles for
#   the MRPT C++ library, the samples, and the applications. Some scripts
#   for generating the documentation, etc. are also updated.
#
#  For compiling instructions for all compilers and platforms, see
#   https://www.mrpt.org/Building_and_Installing_Instructions
#
#  2007-2020, Jose Luis Blanco <jlblanco@ual.es>
#
#  NOTE: CMake can be obtained at http://www.cmake.org/
# ----------------------------------------------------------------------------

if (POLICY CMP0048)
  # cmake warns if loaded from a min-3.x-required parent dir:
  cmake_policy(SET CMP0048 NEW)
endif()

# Tell CMake we'll use both C & C++ for use in its tests/flags.
project(MRPT LANGUAGES C CXX)

# -------------------------
#        Setup CMake
# -------------------------
if (WIN32)
	cmake_minimum_required(VERSION 3.4) # required for CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS
else()
	cmake_minimum_required(VERSION 3.3)
endif()

# CheckIncludeFile: Yes, we will set "CMAKE_REQUIRED_LIBRARIES".
if (POLICY CMP0075)
	cmake_policy(SET CMP0075 NEW)
endif()

if ((NOT IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/nanogui/include")
    OR (NOT IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libfyaml/include")
    OR (NOT IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/rplidar_sdk/sdk/sdk")
   )
  message(FATAL_ERROR "git submodules missing! "
    "You probably did not clone the project with --recursive. It is possible to recover "
    "by calling:\n  git submodule update --init --recursive\n")
endif()

# Display timing information for each compiler instance on screen
option(CMAKE_TIMING_VERBOSE "Enable the display of timing information for each compiler instance." OFF)
mark_as_advanced(CMAKE_TIMING_VERBOSE)

# Enable verbose timing display?
if(CMAKE_TIMING_VERBOSE AND UNIX)
  set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CMAKE_SOURCE_DIR}/cmakemodules/custom_output.sh")
endif(CMAKE_TIMING_VERBOSE AND UNIX)

# Detect wordsize:
if(CMAKE_SIZEOF_VOID_P EQUAL 8)  # Size in bytes!
	set(CMAKE_MRPT_WORD_SIZE 64)
else()
	set(CMAKE_MRPT_WORD_SIZE 32)
endif()

include(cmakemodules/script_version_number.cmake REQUIRED)	#  Loads MRPT version number

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmakemodules") # Directory for CMake scripts

# -------------------------
#            CodeCov
# -------------------------
enable_testing()
find_package(codecov)
# -------------------------

option(MRPT_ALLOW_LGPLV3 "Allows MRPT to use LGPLV3 code (mrpt-vision-lgpl)" "OFF")

# The root directory for all MRPT libraries/modules:
set(MRPT_LIBS_ROOT "${CMAKE_SOURCE_DIR}/libs" CACHE INTERNAL "")  # This emulates global vars

# Windows default: lib. Debian pkgs: set from outside rules script
if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
	set(CMAKE_INSTALL_LIBDIR "lib")
endif()


# ----- Useful macros ------
include(cmakemodules/UtilsMacros.cmake REQUIRED)
include(cmakemodules/DebugMacros.cmake REQUIRED)
include(cmakemodules/FilterFileLists.cmake REQUIRED)
include(cmakemodules/DeclareMRPTLib.cmake REQUIRED)
include(cmakemodules/DeclareMEXLib.cmake REQUIRED)
include(cmakemodules/DeclareAppDependencies.cmake REQUIRED)
include(cmakemodules/script_detect_unix_arch.cmake REQUIRED) # Detect machine architecture, on UNIX
# --------------------------

# Avoid the need for DLL export/import macros in Windows:
if (WIN32)
	set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS  ON)
endif()

# ------------------------------------------
# We want libraries to be named "libXXX"
#  in all compilers, and "-dbg" for debug
# ------------------------------------------
if(MSVC)
	set(MRPT_LIB_PREFIX "lib")  # Libs are: "libXXX"
endif()
set(CMAKE_DEBUG_POSTFIX  "-dbg")

# In case of Makefiles if the user does not setup CMAKE_BUILD_TYPE, assume it's Release:
if (${CMAKE_GENERATOR} MATCHES ".*Makefiles")
    if("${CMAKE_BUILD_TYPE}" STREQUAL "")
        set(CMAKE_BUILD_TYPE Release)
    endif()
endif()

include(cmakemodules/script_select_app_to_build.cmake REQUIRED)		# Build (or not) some apps:

# ----------------------------------------------------------------------------
# 		CHECK FOR SYSTEM LIBRARIES, OPTIONS, ETC..
# ----------------------------------------------------------------------------

# Build static or dynamic libs?
# ===================================================
# Default: dynamic libraries:
set(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries (.dll/.so) instead of static ones (.lib/.a)")
if(BUILD_SHARED_LIBS)
	set(CMAKE_MRPT_BUILD_SHARED_LIB "#define MRPT_BUILT_AS_DLL")
	set(CMAKE_MRPT_BUILD_SHARED_LIB_ONOFF 1)
else()
	set(CMAKE_MRPT_BUILD_SHARED_LIB "/* #define MRPT_BUILT_AS_DLL */")
	set(CMAKE_MRPT_BUILD_SHARED_LIB_ONOFF 0)
endif()

# Only for Unix: use pkg-config to find libraries
# ===================================================
include(FindPkgConfig OPTIONAL)

# Group projects in "folders"
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMakeTargets")

# Build the RoboPeak Lidar library?
set(DEFAULT_BUILD_ROBOPEAK_LIDAR ON) # Default: Yes
if ((${CMAKE_MRPT_KERNEL} MATCHES "GNU") # It doesnt build in hurd
    OR APPLE # and macos
    OR ("$ENV{DEB_TARGET_ARCH_CPU}" STREQUAL "ppc64")   # fails: termios2
    OR ("$ENV{DEB_TARGET_ARCH_CPU}" STREQUAL "ppc64el") # fails: termios2
    OR ("$ENV{DEB_TARGET_ARCH_CPU}" STREQUAL "powerpc") # fails: termios2
    )
	set(DEFAULT_BUILD_ROBOPEAK_LIDAR OFF)
endif()
# Decl option:
set(BUILD_ROBOPEAK_LIDAR ${DEFAULT_BUILD_ROBOPEAK_LIDAR} CACHE BOOL "Build an embedded version of RoboPeak LIDAR SDK (interface to low-cost lidar)")
if(BUILD_ROBOPEAK_LIDAR)
	set(CMAKE_MRPT_HAS_ROBOPEAK_LIDAR 1)
else()
	set(CMAKE_MRPT_HAS_ROBOPEAK_LIDAR 0)
endif()

#-----------------------------------
#  Build the hardware drivers?
#-----------------------------------
set(BUILD_HWDRIVERS ON CACHE BOOL "Build hardware drivers (library apps/lib_hwdrivers)?.")
mark_as_advanced(BUILD_HWDRIVERS)

#-----------------------------------
#  Build with MRPT-MEX compatibility?
#-----------------------------------
set(BUILD_MATLAB OFF CACHE BOOL "Build with compatibility options for MEX wrapper?.")

# GCC only:
# ===================================================
if(CMAKE_COMPILER_IS_GNUCXX)
	# Enable libstdc++ parallel mode?
	set(MRPT_ENABLE_LIBSTD_PARALLEL_MODE OFF CACHE BOOL "Enable parallel mode in libstdc++ (requires GCC 4.2.2+)")
endif()

# Enable precompiled headers:
# ===================================================
if (MSVC)
	set(default_use_precomp ON)
else()
	# JLBC 28th Dec 2017: It seems cotire does not work well with imported -I
	# directories via target_include_directories(... PUBLIC/INTERFACE ...)
	set(default_use_precomp OFF)
endif()
set(MRPT_ENABLE_PRECOMPILED_HDRS ${default_use_precomp} CACHE BOOL "Enable precompiled headers")
mark_as_advanced(MRPT_ENABLE_PRECOMPILED_HDRS)

# MRPT_TRY_START/END blocks
# ===================================================
set(MRPT_HAS_STACKED_EXCEPTIONS ON CACHE BOOL "Enable MRPT_TRY_START/END blocks (disable it for speed up).")

# ASSERT_ blocks
set(MRPT_HAS_ASSERT ON CACHE BOOL "Enable ASSERT_ statements (disable it for speed up).")

# "Classic" function & headers detection:
include(cmakemodules/script_detect_functions_headers.cmake REQUIRED)

# MSVC only:
# ===================================================
if(MSVC)
	# Enable Parallel compilation?
	set(COMPILE_IN_PARALLEL ON CACHE BOOL "Enable parallel compilation in Visual Studio")
endif()

# ----------------------------------------------------------------------------
#   Uninstall target, for "make uninstall"
# Must be invoked *before* other embedded projects so MRPT's target "uninstall" exists first
# ----------------------------------------------------------------------------
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/parse-files/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

set_target_properties(uninstall PROPERTIES FOLDER "CMakeTargets")

# See docs for CMake FindThreads()
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads) # Defines imported target Threads::Threads

# ccache:
if(NOT MSVC AND NOT XCODE_VERSION)
    option(MRPT_BUILD_WITH_CCACHE "Use ccache compiler cache" ON)
    find_program(CCACHE_FOUND ccache)
	mark_as_advanced(CCACHE_FOUND)
    if(CCACHE_FOUND)
        if(MRPT_BUILD_WITH_CCACHE)
            set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
            set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
        else()
            set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "")
            set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK "")
        endif()
    endif()
endif()

# ----------------------------------------------------------------------------
# Other sub-scripts:
# ----------------------------------------------------------------------------
include(cmakemodules/script_assimp.cmake REQUIRED)      # Check for system assimp lib (3D models)
include(cmakemodules/script_bfd.cmake REQUIRED)      # BFD library for debug symbols for stack backtraces
include(cmakemodules/script_clang_tidy.cmake REQUIRED)  # Clang tidy
include(cmakemodules/script_duo3d.cmake REQUIRED)       # Support for DUO3D Camera
include(cmakemodules/script_eigen.cmake REQUIRED)       # Eigen3
include(cmakemodules/script_ffmpeg.cmake REQUIRED)      # Check for ffmpeg C libraries: libavcodec, libavutil, libavformat, libswscale
include(cmakemodules/script_flycapture2.cmake REQUIRED) # Check for PointGreyResearch (PGR) FlyCapture2 library
include(cmakemodules/script_ftdi.cmake REQUIRED)        # Check for the FTDI headers (Linux only, in win32 we use built-in header & dynamic DLL load):
include(cmakemodules/script_gcc_clang_id.cmake REQUIRED) # Helper variables
include(cmakemodules/script_gl_glut.cmake REQUIRED)     # Check for the GL,GLUT libraries
include(cmakemodules/script_gridmap_options.cmake REQUIRED) # Gridmap options
include(cmakemodules/script_gtest.cmake REQUIRED)       # Unit testing lib
include(cmakemodules/script_inotify.cmake REQUIRED)     # Check for the sys/inotify headers (Linux only, in win32 we use the equivalent API for file system monitoring):
include(cmakemodules/script_isense.cmake REQUIRED)      # Support for INTERSENSE Sensors
include(cmakemodules/script_iwyu.cmake REQUIRED)        # Include-what-you-use
include(cmakemodules/script_jpeg.cmake REQUIRED)        # Check for jpeg
include(cmakemodules/script_jsoncpp.cmake REQUIRED)     # Check for jsoncpp
include(cmakemodules/script_kinect.cmake REQUIRED)      # Kinect support in a set of different ways
include(cmakemodules/script_libdc1394.cmake REQUIRED)   # Check for libdc1394-2
include(cmakemodules/script_libfyaml.cmake REQUIRED)    # Defines embedded version of libfyaml
include(cmakemodules/script_liblas.cmake REQUIRED)      # Check for the LAS LiDAR format library
include(cmakemodules/script_libtclap.cmake REQUIRED)    # Check for system libtclap
include(cmakemodules/script_matlab.cmake REQUIRED)      # Support for Matlab MEX functions generation
include(cmakemodules/script_mynteye.cmake REQUIRED)     # Support for MYNT EYE cameras
include(cmakemodules/script_nanogui.cmake REQUIRED)     # Check for nanogui
include(cmakemodules/script_national_instruments.cmake REQUIRED)  # NI C library
include(cmakemodules/script_nite2.cmake REQUIRED)       # Check for NITE2 library
include(cmakemodules/script_octomap.cmake REQUIRED)     # Check for the octomap library
include(cmakemodules/script_opencv.cmake REQUIRED)      # Check for the OpenCV libraries (via pkg-config, CMake, with different options)
include(cmakemodules/script_openni2.cmake REQUIRED)     # Check for the OpenNI2 library

=== 3rdparty/CMakeLists.txt ===

include(../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

# ----------------------------------
# wxThings
# ----------------------------------
if(CMAKE_MRPT_HAS_WXWIDGETS)
	add_subdirectory(wxThings)
endif()

# ----------------------------------
# libfreenect: Embedded version
# ----------------------------------
if(CMAKE_MRPT_HAS_FREENECT AND NOT CMAKE_MRPT_HAS_FREENECT_SYSTEM)

	find_package(libusb-1.0)

	# Special stuff for windows:
	set(SRCS
		libfreenect/src/cameras.c
		libfreenect/src/core.c
		libfreenect/src/flags.c
		libfreenect/src/loader.c
		libfreenect/src/registration.c
		libfreenect/src/audio.c
		libfreenect/src/tilt.c
		libfreenect/src/usb_libusb10.c
	)

	if (WIN32)
		list(APPEND SRCS
			libfreenect/platform/windows/libusb10emu/libusb-1.0/libusbemu.cpp
			libfreenect/platform/windows/libusb10emu/libusb-1.0/failguard.cpp
			)
	endif()

	add_library(mrpt_freenect STATIC ${SRCS})

	if (WIN32)
		target_include_directories(mrpt_freenect SYSTEM PUBLIC
			${MRPT_SOURCE_DIR}/3rdparty/libfreenect/platform/windows
			${MRPT_SOURCE_DIR}/3rdparty/libfreenect/platform/windows/libusb10emu
		)
	endif()

	if (MSVC)
		set_source_files_properties(${SRCS} PROPERTIES LANGUAGE CXX) # Build as C++
	endif()

	if (MRPT_COMPILER_IS_GCC_OR_CLANG)
		target_compile_options(mrpt_freenect PRIVATE
			-fPIC
			-Wno-ignored-qualifiers
			-Wno-unused-function
			-Wno-unused-const-variable
		)
	endif()

	# Embedded version:
	target_include_directories(mrpt_freenect SYSTEM PUBLIC
		${MRPT_SOURCE_DIR}/3rdparty/libfreenect/include
	)
	# libfreenect.h includes libusb.h:
	if (LIBUSB_1_INCLUDE_DIRS)
		target_include_directories(mrpt_freenect SYSTEM PUBLIC
			${LIBUSB_1_INCLUDE_DIRS}
			${LIBUSB_1_INCLUDE_DIRS}/libusb-1.0
		)
	endif()
	if (LIBUSB_1_LIBRARIES)
		message(STATUS "LIBUSB_1_LIBRARIES: ${LIBUSB_1_LIBRARIES}")
		target_link_libraries(mrpt_freenect PUBLIC ${LIBUSB_1_LIBRARIES})
	endif()
	set_target_properties(mrpt_freenect PROPERTIES FOLDER "3rd party")

	unset(SRCS)
endif()

# ----------------------------------
# Build RPLIDAR?
# ----------------------------------
if(CMAKE_MRPT_HAS_ROBOPEAK_LIDAR)
	set(RPLIDAR_ROOT ${MRPT_SOURCE_DIR}/3rdparty/rplidar_sdk/sdk/sdk/)
	set(SRCS_LIST
		${RPLIDAR_ROOT}/src/*.cpp
		${RPLIDAR_ROOT}/src/hal/*.cpp
		${RPLIDAR_ROOT}/include/*.h
	)
	if (WIN32)
		list(APPEND SRCS_LIST ${RPLIDAR_ROOT}/src/arch/win32/*.cpp)
	else()
		list(APPEND SRCS_LIST ${RPLIDAR_ROOT}/src/arch/linux/*.cpp)
	endif()
	file(GLOB SRCS ${SRCS_LIST})

	add_library(mrpt_rplidar STATIC ${SRCS})

	if (MRPT_COMPILER_IS_GCC_OR_CLANG)
		target_compile_options(mrpt_rplidar PRIVATE
			-fPIC
		)
	endif()
	if(MSVC)
		target_compile_options(mrpt_rplidar PRIVATE /DWIN64)
	endif()
	if (MRPT_COMPILER_IS_CLANG)
		target_compile_options(mrpt_rplidar PRIVATE -Wno-c++11-narrowing)
	endif()
	if (CMAKE_COMPILER_IS_GNUCXX)
		target_compile_options(mrpt_rplidar PRIVATE -Wno-narrowing)
	endif()

	# Embedded version:
	target_include_directories(mrpt_rplidar SYSTEM PUBLIC
		${RPLIDAR_ROOT}/include/
		${RPLIDAR_ROOT}/src/
	)
	set_target_properties(mrpt_rplidar PROPERTIES FOLDER "3rd party")

	target_link_libraries(mrpt_rplidar PRIVATE mrpt::core) # To enforce c++17

	unset(SRCS_LIST)
	unset(SRCS)
	unset(RPLIDAR_ROOT)
endif()

# ----------------------------------
# Build xSens IMU library
# ----------------------------------
if(CMAKE_MRPT_HAS_xSENS)
	file(GLOB_RECURSE SRCS
		xspublic/*.cpp
		xspublic/*.c
		xspublic/*.h
	)

	add_library(mrpt_xsens STATIC ${SRCS})

	if (MRPT_COMPILER_IS_GCC_OR_CLANG)
		target_compile_options(mrpt_xsens PRIVATE
			-fPIC
			-fms-extensions  # Unnamed structs in unions
			-Wno-variadic-macros
			-Wno-parentheses
		)
		target_compile_definitions(mrpt_xsens PRIVATE
			_POSIX_C_SOURCE=200809L  # Needed to have CLOCK_REALTIME,... in gcc
			_LOG_TO_STDOUT
		)
	endif()

	# Embedded version:
	target_include_directories(mrpt_xsens SYSTEM PUBLIC
		${MRPT_SOURCE_DIR}/3rdparty/xspublic/
		${MRPT_SOURCE_DIR}/3rdparty/xspublic/xstypes/
		${MRPT_SOURCE_DIR}/3rdparty/xspublic/xscommon/
		${MRPT_SOURCE_DIR}/3rdparty/xspublic/xscontroller/
	)

	# Couldn't make this to work with a regular target_compile_options() cmd:
	if (MSVC)
		set(xsens_flag "/FI ${MRPT_SOURCE_DIR}/3rdparty/xspublic/msvc_include.h ")
	else()
		set(xsens_flag "-include xscommon_config.h -include xsens_compat.h -include xscontrollerconfig.h ")
	endif()
	set_property(TARGET mrpt_xsens APPEND_STRING
		PROPERTY COMPILE_FLAGS ${xsens_flag}
	)

	if (MSVC)
		target_compile_definitions(mrpt_xsens PRIVATE XDA_STATIC_LIB)
	endif()


  # Feature should be "cxx_std_11", but it's unknown to cmake 3.5.1 in Xenial:
	target_compile_features(mrpt_xsens PRIVATE cxx_constexpr)
	set_target_properties(mrpt_xsens PROPERTIES FOLDER "3rd party")
	unset(SRCS)
endif()



# ----------------------------------
# Built-in version of freeglut?
# ----------------------------------
if(CMAKE_MRPT_HAS_OPENGL_GLUT AND NOT CMAKE_MRPT_HAS_OPENGL_GLUT_SYSTEM)
	file(GLOB SRCS
		freeglut/*.c
		freeglut/GL/*.h
	)
	add_library(mrpt_freeglut STATIC ${SRCS})

	if (MRPT_COMPILER_IS_GCC_OR_CLANG)
		target_compile_options(mrpt_freeglut PRIVATE
			-fPIC
		)
	endif()
	CHECK_INCLUDE_FILE("sys/time.h" HAVE_SYS_TIME_H)
	CHECK_INCLUDE_FILE("sys/ioctl.h" HAVE_SYS_IOCTL_H)
	CHECK_INCLUDE_FILE("fcntl.h" HAVE_FCNTL_H)
	CHECK_INCLUDE_FILE("unistd.h" HAVE_UNISTD_H)

	target_compile_definitions(mrpt_freeglut PUBLIC
		FREEGLUT_STATIC # or /DFREEGLUT_EXPORTS
		HAVE_SYS_TIME_H=$<BOOL:${HAVE_SYS_TIME_H}>
		HAVE_SYS_IOCTL_H=$<BOOL:${HAVE_SYS_IOCTL_H}>
		HAVE_FCNTL_H=$<BOOL:${HAVE_FCNTL_H}>
		HAVE_UNISTD_H=$<BOOL:${HAVE_UNISTD_H}>
		)

	# Embedded version:
	target_include_directories(mrpt_freeglut SYSTEM PUBLIC
		${MRPT_SOURCE_DIR}/3rdparty/freeglut/
	)
	set_target_properties(mrpt_freeglut PROPERTIES FOLDER "3rd party")

	# Depend on X11 lib:
	if (UNIX)
		target_link_libraries(mrpt_freeglut PUBLIC
			X11
			${OPENGL_glu_LIBRARY}
		)
	endif()
	unset(SRCS)
endif()

# ----------------------------------
# Built-in version of Glew?
# ----------------------------------
if(WIN32)
	file(GLOB SRCS
		glew/src/glew.c
		glew/include/GL/*.h
	)
	add_library(mrpt_glew STATIC ${SRCS})

	if (MRPT_COMPILER_IS_GCC_OR_CLANG)
		target_compile_options(mrpt_glew PRIVATE
			-fPIC
		)
	endif()

	target_compile_definitions(mrpt_glew PUBLIC
		GLEW_STATIC
	)

	# Embedded version:
	target_include_directories(mrpt_glew SYSTEM PUBLIC
		${MRPT_SOURCE_DIR}/3rdparty/glew/include/
		${MRPT_SOURCE_DIR}/3rdparty/glext/include/
	)
	set_target_properties(mrpt_glew PROPERTIES FOLDER "3rd party")
	unset(SRCS)
endif()

# ----------------------------------
# nanogui:
# ----------------------------------
# Already handled in cmakemodules/script_nanogui.cmake

# ----------------------------------
# libfyaml
# ----------------------------------
# already handled in cmakemodules/script_libfyaml.cmake

# ----------------------------------
# simpleini
# ----------------------------------
# already handled in cmakemodules/script_simpleini.cmake

# ----------------------------------
# googletest
# ----------------------------------
if (NOT CMAKE_MRPT_HAS_GTEST_SYSTEM)
	add_library(mrptgtest
		STATIC
		${MRPT_SOURCE_DIR}/3rdparty/googletest/googletest/src/gtest-all.cc
		)

	target_include_directories(mrptgtest PRIVATE
		${MRPT_SOURCE_DIR}/3rdparty/googletest/googletest/src/
		${MRPT_SOURCE_DIR}/3rdparty/googletest/googletest/
	)
	target_include_directories(mrptgtest PUBLIC
		${MRPT_SOURCE_DIR}/3rdparty/googletest/googletest/include/
	)

	mrpt_lib_target_requires_cpp17(mrptgtest)

	if (UNIX AND MRPT_COMPILER_IS_GCC_OR_CLANG)
		target_compile_options(mrptgtest PRIVATE -fPIC)
	endif()
	# Fix a "bug" in VS11 (MSVC 2012):
	if(MSVC)
		target_compile_definitions(mrptgtest PUBLIC _VARIADIC_MAX=10)
	endif()
	if(MRPT_COMPILER_IS_CLANG AND APPLE)
		target_compile_definitions(mrptgtest PUBLIC GTEST_USE_OWN_TR1_TUPLE=1)
	endif()

	set_target_properties(mrptgtest PROPERTIES FOLDER "3rd party")
endif()

=== doc/CMakeLists.txt ===
include(../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

project(documentation)

# Dummy documentation target for showing grouped files in IDEs:
# ----------------------------------------------------------------------------
file(GLOB_RECURSE RST_FILES "${CMAKE_SOURCE_DIR}/doc/*.rst")
file(GLOB_RECURSE MD_FILES "${CMAKE_SOURCE_DIR}/doc/*.md")
file(GLOB_RECURSE H_FILES "${CMAKE_SOURCE_DIR}/doc/sources/*.h")
set(DOC_INDIV_FILES
	"${CMAKE_SOURCE_DIR}/README.md"
	)
set(all_docs_files ${RST_FILES} ${H_FILES} ${DOC_INDIV_FILES} ${MD_FILES})
add_custom_target(DocumentationFiles DEPENDS ${all_docs_files} SOURCES ${all_docs_files})
set_target_properties(DocumentationFiles PROPERTIES FOLDER "documentation")

# Manpages
# ----------------------------------------------------------------------------
if(UNIX)
	add_subdirectory(man-pages)
endif()

# Compile Latex targets:
if(NOT WIN32)
find_program(LATEXMK_PROGRAM latexmk)
mark_as_advanced(LATEXMK_PROGRAM)
if(LATEXMK_PROGRAM)
	# The main (empty) target:
	add_custom_target(documentation_psgz_guides)

	# graphslam-engine-guide
	add_custom_target(documentation_graphslam-engine-guide
		COMMAND 		make -C ${MRPT_SOURCE_DIR}/doc/graphslam-engine-guide/ graphslam-engine-guide.ps.gz
		COMMENT 		"Generating graphslam-engine-guide (ps.gz)"
		)
	add_dependencies(documentation_psgz_guides documentation_graphslam-engine-guide)
endif()
endif()

=== doc/requirements.txt ===
sphinx_rtd_theme
sphinx-panels
sphinxcontrib-bibtex

=== python/CMakeLists.txt ===
project(pymrpt)

find_package(PythonInterp)

# Note: relative paths are relative to ${CMAKE_INSTALL_PREFIX} (defaults to /usr/local on Ubuntu)
set( PYMRPT_INSTALL_DIR "lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/dist-packages" )

include_directories(include)
include_directories(
  ${Boost_INCLUDE_DIRS}
  ${PYTHON_INCLUDE_DIRS}
)
# Find Numpy include directory
execute_process(
    COMMAND
    "${PYTHON_EXECUTABLE}" -c
# multiline string; indentation would break this
"try:
    import sys
    import numpy
    sys.stdout.write(numpy.get_include())
except:
    pass
"
    OUTPUT_VARIABLE MRPT_NUMPY_INCLUDE_DIRECTORY
)
if(MRPT_NUMPY_INCLUDE_DIRECTORY)
  include_directories(${MRPT_NUMPY_INCLUDE_DIRECTORY})
endif()

# gcc and clang
if (NOT MSVC)
	add_compile_options(-Wno-unused-local-typedef)
endif()

add_library(pymrpt
  SHARED # Python lib must be shared
  src/system_bindings.cpp
  src/utils_bindings.cpp
  src/kinematics_bindings.cpp
  src/poses_bindings.cpp
  src/slam_bindings.cpp
  src/maps_bindings.cpp
  src/obs_bindings.cpp
  src/nav_bindings.cpp
  src/gui_bindings.cpp
  src/opengl_bindings.cpp
  src/math_bindings.cpp
  src/bayes_bindings.cpp
  src/pnp_bindings.cpp
  src/bindings.cpp
)

# disable eigen: python and eigen alignment seem not to be best friends
#add_definitions(-DEIGEN_DONT_VECTORIZE -DEIGEN_DISABLE_UNALIGNED_ARRAY_ASSERT)
# uncomment to disable ROS support
add_definitions(-DROS_EXTENSIONS)

target_link_libraries(pymrpt
  ${Boost_LIBRARIES}
  imp_opencv
  Python3::Python
)

# remove "lib" prefix from .so filename
set_target_properties(pymrpt PROPERTIES PREFIX "")

install(TARGETS pymrpt
  LIBRARY DESTINATION ${PYMRPT_INSTALL_DIR}
)

# Dependencies (link & includes):
DeclareAppDependencies(pymrpt mrpt::poses mrpt::slam mrpt::obs mrpt::maps mrpt::nav mrpt::gui mrpt::opengl mrpt::vision)

=== samples/CMakeLists.txt ===
project(ALL_EXAMPLES)

add_custom_target(examples ALL)

set(BUILD_EXAMPLES OFF CACHE BOOL "Build examples?")
if(BUILD_EXAMPLES)
	set(CMAKE_MRPT_EXAMPLES_BASE_DIRECTORY ${CMAKE_CURRENT_LIST_DIR})

	# Generate examples_config.h
	configure_file(
    "${MRPT_SOURCE_DIR}/parse-files/examples_config.h.in"
    "${MRPT_CONFIG_FILE_INCLUDE_DIR}/mrpt/examples_config.h")

	# Generate CMakeLists.txt for each example:
	message(STATUS "Generating CMakefiles.txt for examples...")

	# ---------------------------------------------------------------
	#  MACRO for samples directories
	# ---------------------------------------------------------------
	macro(GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY)
		#TODO: Disable build if BUILD_mrpt_xxx is OFF

		# Convert CMAKE_EXAMPLE_DEPS -> CMAKE_EXAMPLE_DEPS_STRIP
		#          "mrpt::xxx mrpt::yyy" -> "xxx yyy"
		set(CMAKE_EXAMPLE_DEPS_STRIP "")
		foreach(DEP ${CMAKE_EXAMPLE_DEPS})
		    # Only for "mrpt::XXX" libs:
			if (DEP MATCHES "^mrpt::?:*(.*)")
			    string(REGEX REPLACE "mrpt::?:*(.*)" "\\1" STRIP_DEP ${DEP})
				list(APPEND CMAKE_EXAMPLE_DEPS_STRIP ${STRIP_DEP})
			endif()
		endforeach(DEP)

		foreach(CMAKE_MRPT_EXAMPLE_NAME ${LIST_EXAMPLES_IN_THIS_DIR})
			# Generate project file:
			configure_file(
			  ${MRPT_SOURCE_DIR}/samples/CMakeLists_template.txt.in
			  ${MRPT_SOURCE_DIR}/samples/${CMAKE_MRPT_EXAMPLE_NAME}/CMakeLists.txt
			  @ONLY)
			# And parse it:
			add_subdirectory(${CMAKE_MRPT_EXAMPLE_NAME})
		endforeach()
	endmacro()
	# ---------------------------------------------------------------
	#  END OF MACRO for samples directories
	# ---------------------------------------------------------------


	# === Depending on: core ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		core_exceptions_example
		core_backtrace_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::core)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: typemeta ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		typemeta_TTypeName
		typemeta_StaticString
		typemeta_TEnumType
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::typemeta)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: rtti ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		rtti_example1
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::rtti)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: containers, systems ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		containers_yaml_example
		containers_params_by_name
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::containers mrpt::system)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()


	# === Depending on: serialization, io ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		# ----
		serialization_json_example
		serialization_stl
		serialization_variant_example
		# ----
		io_pipes_example
		io_compress_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::serialization mrpt::io mrpt::poses)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: system ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		system_datetime_example
		system_directory_explorer_example
		system_file_system_watcher
		system_dirs_files_manipulation
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::system mrpt::poses mrpt::io)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: system+math+gui ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		system_control_rate_timer_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::system mrpt::math mrpt::gui mrpt::tclap)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::math mrpt::random mrpt::gui ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		math_csparse_example
		math_kmeans_example
		math_matrix_example
		math_optimize_lm_example
		math_slerp_example
		math_spline_interpolation
		math_leastsquares_example
		math_ransac_plane3d_example
		math_ransac_plane3d_example2
		math_ransac_examples
		math_model_search_example
		math_polygon_split
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::math mrpt::random mrpt::gui mrpt::maps)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	set(LIST_EXAMPLES_IN_THIS_DIR
		math_polyhedron_intersection_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::math mrpt::random mrpt::gui mrpt::maps)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::poses ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		poses_geometry_3D_example
		poses_pdfs_example
		poses_se3_lie_example
		poses_quaternions_example
		poses_sog_merge_example
		poses_unscented_transform_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::poses mrpt::io mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::comms ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		comms_http_client
		comms_nodelets_example
		comms_serial_port_example
		comms_socket_example
		comms_ftdi_usb_enumerate_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::comms mrpt::serialization mrpt::poses)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::gui, mrpt::img, mrpt::opengl, mrpt::maps ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		# -------
		opengl_objects_demo
		opengl_offscreen_render_example
		opengl_octree_render_huge_pointcloud
		opengl_texture_sizes_test
		# -------
		img_basic_example
		img_convolution_fft
		img_fft_example
		img_gauss_filtering_example
		# -------
		gui_capture_render_to_img_example
		gui_display3D_example
		gui_display3D_custom_render
		gui_fbo_render_example
		gui_display_plots
		gui_nanogui_demo
		gui_text_fonts_example
		gui_gravity3d_example
		gui_windows_events
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::gui mrpt::maps)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::gui, mrpt::hwdrivers ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		opengl_video_demo
		opengl_video_viewport_demo
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::gui mrpt::hwdrivers)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::gui, mrpt::maps ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		opengl_ray_trace_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::gui mrpt::maps)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::random ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		random_examples
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::random mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::bayes, mrpt::obs, mrpt::gui ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		bayes_tracking_example
		bayes_rejection_sampling_example
		bayes_resampling_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::bayes mrpt::obs mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: maps ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		# -----
		maps_gridmap_likelihood_characterization
		maps_gridmap_voronoi_example
	)
    set(CMAKE_EXAMPLE_DEPS mrpt::maps mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: slam ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		maps_gridmap_benchmark
		slam_icp_simple_example
		slam_icp3d_simple_example
		slam_range_only_localization_rej_sampling_example
	)
    set(CMAKE_EXAMPLE_DEPS mrpt::slam mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: topography ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		topography_gps_coords_example
		topography_coordinate_conversion_example
	)
    set(CMAKE_EXAMPLE_DEPS mrpt::topography)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: vision ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		vision_create_video_file_example
		vision_checkerboard_detectors
		vision_feature_extraction
		vision_keypoint_matching_example
		vision_multiple_checkerboards
		vision_stereo_calib_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::vision mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	if(MRPT_ALLOW_LGPLV3)
		# === Depending on: vision-lgpl ===
		set(LIST_EXAMPLES_IN_THIS_DIR
			vision_bundle_adj_example
			)
		set(CMAKE_EXAMPLE_DEPS mrpt::vision-lgpl mrpt::gui)
		GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()
	endif()

	# === Depending on: obs ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		obs_mox_model_rawlog
		# special utilities:
		rgbd_dataset2rawlog
		kitti_dataset2rawlog
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::obs)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: maps, gui ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		maps_laser_projection_in_images_example
		maps_gridmap3D_simple
		maps_observer_pattern_example
		maps_octomap_simple
		maps_gmrf_map_example
		maps_ransac_data_association
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::maps mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: graphs & gui ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		graphs_astar_example
		graphs_dijkstra_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::graphs mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: graphslam & gui ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		graphslam_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::graphslam mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: gui & hwdrivers ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		hwdrivers_camera_capture_dialog
		hwdrivers_capture_video_opencv
		hwdrivers_capture_video_dc1394
		hwdrivers_capture_video_ffmpeg
		hwdrivers_capture_video_flycapture2
		hwdrivers_capture_video_flycapture2_stereo
		hwdrivers_enumerate_cameras1394
		hwdrivers_gps_example
		hwdrivers_joystick_example
		hwdrivers_ntrip_client_example
		hwdrivers_phidget_proximity_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::hwdrivers mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: maps & hwdrivers ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		hwdrivers_swissranger_example
		hwdrivers_sick_serial_example
		hwdrivers_sick_eth_example
		hwdrivers_hokuyo_example
		hwdrivers_robopeaklidar_example
		hwdrivers_kinect_to_2d_scan_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::hwdrivers mrpt::maps)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: slam & hwdrivers ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		hwdrivers_kinect_online_offline_example
		hwdrivers_mynteye_icp
	)
    set(CMAKE_EXAMPLE_DEPS mrpt::slam mrpt::hwdrivers)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === HWDRIVERS & VISION ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		vision_capture_video_build_pyr
		vision_stereo_rectify
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::vision mrpt::hwdrivers)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === HWDRIVERS & DETECTORS ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		detectors_face
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::slam mrpt::hwdrivers mrpt::detectors)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === OPENNI2 examples ===
	if (MRPT_HAS_OPENNI2)
		set(LIST_EXAMPLES_IN_THIS_DIR
			hwdrivers_openni2_driver_demo
			hwdrivers_openni2_2d_icp_slam
			)
		set(CMAKE_EXAMPLE_DEPS mrpt::hwdrivers mrpt::gui mrpt::opengl mrpt::maps)
		GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()
	endif(MRPT_HAS_OPENNI2)

	# === Navigation examples ===
	if(BUILD_mrpt-nav)
		set(LIST_EXAMPLES_IN_THIS_DIR
			nav_circ_robot_path_planning
			nav_rrt_planning_example
			)
		set(CMAKE_EXAMPLE_DEPS mrpt::nav mrpt::gui)
		GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()
	endif()

	message(STATUS "Done.")
endif()

=== tests/CMakeLists.txt ===
include(../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

# ----------------------------------------------------------------------------
#   TESTS
# ----------------------------------------------------------------------------
project(tests)

set(EXECUTABLE_OUTPUT_PATH "${MRPT_BINARY_DIR}/bin")

# -----------------------------
# Add the "make test" target:
# -----------------------------
add_custom_target(test_legacy)
add_custom_target(tests_build_all)
set_target_properties(test_legacy PROPERTIES FOLDER "unit tests")
set_target_properties(tests_build_all PROPERTIES FOLDER "unit tests")
if (UNIX)
	add_custom_target(test_gdb)
	add_custom_target(test_valgrind)
endif()


add_definitions(-DCMAKE_UNITTEST_BASEDIR="${MRPT_SOURCE_DIR}")

# Allow tests to include sources from examples directory:
include_directories("${MRPT_SOURCE_DIR}")
# Include tests-specific hdrs:
include_directories("${MRPT_SOURCE_DIR}/tests/include")

# Tests based on Google gtest:
# -----------------------------

# Include gtest from embeded lib:
if (NOT CMAKE_MRPT_HAS_GTEST_SYSTEM)
	include_directories("${CMAKE_MRPT_GTEST_SRC_DIR}/include/")
endif()

# If using system library, add C++ flags:
if (NOT "${CMAKE_GTEST_CFLAGS}" STREQUAL "")
	add_definitions(${CMAKE_GTEST_CFLAGS})
endif ()

if(MSVC)
	# avoid MSVC pedantic warning on tr1. See: https://github.com/google/googletest/issues/1111
	add_definitions(/D_SILENCE_TR1_NAMESPACE_DEPRECATION_WARNING)
endif()


get_property(LST_LIB_TESTS GLOBAL PROPERTY "MRPT_TEST_LIBS")
foreach(_TSTLIB ${LST_LIB_TESTS})
	string(REGEX REPLACE "mrpt_(.*)" "mrpt-\\1" _TSTLIB_DASH ${_TSTLIB})
	get_property(lstfiles GLOBAL PROPERTY "${_TSTLIB}_UNIT_TEST_FILES")

	#message(STATUS "Generating tests for ${_TSTLIB} -> ${_TSTLIB_DASH}")
	#message(STATUS "  Files: ${lstfiles}")

	# Test project:
	add_executable( test_${_TSTLIB} test_main.cpp ${lstfiles})
	add_test(test_${_TSTLIB}_build "${CMAKE_COMMAND}" --build ${CMAKE_BINARY_DIR} --target test_${_TSTLIB})
	add_test(test_${_TSTLIB}_run ${EXECUTABLE_OUTPUT_PATH}/test_${_TSTLIB})
	set_tests_properties(test_${_TSTLIB}_run PROPERTIES DEPENDS test_${_TSTLIB}_build)

	add_coverage(test_${_TSTLIB})

	# Add the required libraries for linking:
	if (CMAKE_MRPT_HAS_GTEST_SYSTEM)
		# System vesion:
		set(gtest_lib_name gtest)
	else ()
		# Own version:
		set(gtest_lib_name mrptgtest)
	endif ()

	target_link_libraries(test_${_TSTLIB} ${gtest_lib_name} Threads::Threads)

	# Deps:
	get_property(lst_deps GLOBAL PROPERTY "${_TSTLIB_DASH}_LIB_DEPS")
	# extra deps:
	get_property(extra_deps GLOBAL PROPERTY "${_TSTLIB}_UNIT_TEST_EXTRA_DEPS")
	set(lst_deps ${lst_deps} ${extra_deps})

	# The order in this list is very important for linking!
	# Otherwise, one may have the weird linking error:
	# "error adding symbols: DSO missing from command line"
	set(lst_deps ${_TSTLIB_DASH} ${lst_deps})
	foreach(_DEPLIB ${lst_deps})
		# Include dirs:
		if (_DEPLIB MATCHES "^mrpt-?:*(.*)")
			string(REGEX REPLACE "mrpt-?:*(.*)" "\\1" _DEPLIB_DASH ${_DEPLIB})
			# This link command automatically imports all required "include directories"
			# and other PUBLIC dependencies of the linked target:
			target_link_libraries(test_${_TSTLIB} mrpt::${_DEPLIB_DASH})
		else()
			target_link_libraries(test_${_TSTLIB} ${_DEPLIB})
		endif()
	endforeach(_DEPLIB)

	# Run it:
	set(GENERATED_EXE "$<TARGET_FILE:test_${_TSTLIB}>")
	add_custom_target(run_tests_${_TSTLIB} COMMAND "${GENERATED_EXE}")
	add_dependencies(run_tests_${_TSTLIB} test_${_TSTLIB})
	add_dependencies(test_legacy run_tests_${_TSTLIB})
	add_dependencies(tests_build_all test_${_TSTLIB})

	if (UNIX)
		# test_gdb
		add_custom_target(run_tests_${_TSTLIB}_gdb
			COMMAND "gdb" "-batch" "-ex" "\"run\"" "-ex" "\"bt\"" "-return-child-result" "${GENERATED_EXE}"
			)
		add_dependencies(run_tests_${_TSTLIB}_gdb test_${_TSTLIB})
		add_dependencies(test_gdb run_tests_${_TSTLIB}_gdb)

		# test_valgrind
		add_custom_target(run_tests_${_TSTLIB}_valgrind
			COMMAND "valgrind" "--error-exitcode=1" "${GENERATED_EXE}"
			)
		add_dependencies(run_tests_${_TSTLIB}_valgrind test_${_TSTLIB})
		add_dependencies(test_valgrind run_tests_${_TSTLIB}_valgrind)
	endif()

	set_target_properties(test_${_TSTLIB} PROPERTIES FOLDER "unit tests")
	set_target_properties(run_tests_${_TSTLIB} PROPERTIES FOLDER "unit tests")

	if (MRPT_COMPILER_IS_GCC_OR_CLANG)
		target_compile_options(test_${_TSTLIB} PRIVATE "-Wno-abi")
	endif()

endforeach()

# Special dependencies:
if (TARGET test_mrpt_img)
    if(CMAKE_MRPT_HAS_OPENCV)
	target_link_libraries(test_mrpt_img imp_opencv)
    endif()
endif()

=== 3rdparty/libfyaml/CMakeLists.txt ===
if (POLICY CMP0048)
    cmake_policy(SET CMP0048 NEW) # Allow project(xxx VERSION a.b.c)
endif()


project(fyaml LANGUAGES C VERSION 0.5.8)

cmake_minimum_required(VERSION 3.0)

# Must use GNUInstallDirs to install libraries into correct
# locations on all platforms.
include(GNUInstallDirs)

file(GLOB_RECURSE
    LIBHDRS
    "src/*.h"
)
file(GLOB
    LIBSRCS
    "src/lib/*.c"
    "src/xxhash/*.c"
)
file(GLOB_RECURSE
    LIBHDRSPUB
    "include/*.h"
)

add_library(${PROJECT_NAME}
    ${LIBHDRS}
    ${LIBSRCS}
    ${LIBHDRSPUB}
)

add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER "Libraries")

target_include_directories(${PROJECT_NAME}
    PUBLIC
        $<BUILD_INTERFACE:${${PROJECT_NAME}_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
    PRIVATE
        ${${PROJECT_NAME}_SOURCE_DIR}/src/lib
        ${${PROJECT_NAME}_SOURCE_DIR}/src/lib/internal
        ${${PROJECT_NAME}_SOURCE_DIR}/src/xxhash
)

#target_link_libraries(${PROJECT_NAME} PUBLIC xx)
#target_compile_definitions(${PROJECT_NAME} PUBLIC xx)

target_compile_definitions(${PROJECT_NAME} PRIVATE
    VERSION="0.5.7.34"
)

target_compile_definitions(${PROJECT_NAME} PRIVATE
  $<$<NOT:$<CONFIG:DEBUG>>:NDEBUG>
)

# Shared options between GCC and CLANG:
if (NOT MSVC)
	target_compile_options(${PROJECT_NAME} PRIVATE
        -Wall
        -fPIC
        -D_GNU_SOURCE
    )

	if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
		target_compile_options(${PROJECT_NAME} PRIVATE
            -O2
        )
	endif()
endif()

# ==== Install & export target ========

install(TARGETS	${PROJECT_NAME}
		EXPORT 	${PROJECT_NAME}-targets
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(EXPORT ${PROJECT_NAME}-targets
    FILE ${PROJECT_NAME}-targets.cmake
    NAMESPACE ${PROJECT_NAME}::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)
export(
	TARGETS ${PROJECT_NAME}
	FILE "${CMAKE_BINARY_DIR}/cmake/${PROJECT_NAME}-targets.cmake"
	NAMESPACE mbse::
)


include(CMakePackageConfigHelpers)
configure_package_config_file(
    ${CMAKE_SOURCE_DIR}/cmake/${PROJECT_NAME}-config.cmake.in
    ${CMAKE_BINARY_DIR}/cmake/${PROJECT_NAME}-config.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)

write_basic_package_version_file(
    ${CMAKE_BINARY_DIR}/cmake/${PROJECT_NAME}-config-version.cmake
    VERSION ${YART_VERSION}
    COMPATIBILITY AnyNewerVersion
)

install(
    FILES
        ${CMAKE_BINARY_DIR}/cmake/${PROJECT_NAME}-config.cmake
        ${CMAKE_BINARY_DIR}/cmake/${PROJECT_NAME}-config-version.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)

=== 3rdparty/mexplus/CMakeLists.txt ===
project( mexplus )

# Code below is just for accessibility issues in IDE editor
# List all files (headers) contained by mexplus library
file(GLOB_RECURSE all_mexplus_files RELATIVE "${CMAKE_SOURCE_DIR}/3rdparty/mexplus" *.h *.hpp)
# Visualize the files of this directory in IDE creating an custom empty target
add_custom_target(mexplus DEPENDS ${all_mexplus_files} SOURCES ${all_mexplus_files})

=== 3rdparty/nanogui/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

if (POLICY CMP0048)
  # cmake warns if loaded from a min-3.0-required parent dir, so silence the warning:
  cmake_policy(SET CMP0048 NEW)
endif()

project(mrpt-nanogui)

if (POLICY CMP0058)
  cmake_policy(SET CMP0058 NEW)
endif()

if (NOT IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/ext/nanovg/src")
  message(FATAL_ERROR "The NanoGUI dependency repositories (NANOVG, etc.) are missing! "
    "You probably did not clone the project with --recursive. It is possible to recover "
    "by calling \"git submodule update --init --recursive\"")
endif()

if (WIN32)
  set(NANOGUI_USE_GLAD_DEFAULT ON)
else()
  set(NANOGUI_USE_GLAD_DEFAULT OFF)
endif()

set(NANOGUI_BUILD_SHARED_DEFAULT ON)

option(NANOGUI_BUILD_EXAMPLE "Build NanoGUI example application?" OFF)
set(NANOGUI_BUILD_SHARED ${NANOGUI_BUILD_SHARED_DEFAULT} CACHE BOOL "Build NanoGUI as a shared library?" FORCE)
option(NANOGUI_BUILD_PYTHON  "Build a Python plugin for NanoGUI?" OFF)
option(NANOGUI_USE_GLAD      "Use Glad OpenGL loader library?" ${NANOGUI_USE_GLAD_DEFAULT})
option(NANOGUI_INSTALL       "Install NanoGUI on `make install`?" ON)

set(NANOGUI_PYTHON_VERSION "" CACHE STRING "Python version to use for compiling the Python plugin")

# Platform-dependent files for libnanogui
set(LIBNANOGUI_EXTRA_SOURCE "")
set(LIBNANOGUI_PYTHON_EXTRA_SOURCE "")

if(APPLE AND NANOGUI_BUILD_SHARED)
  set(CMAKE_MACOSX_RPATH ON)
endif()

include(CheckCXXCompilerFlag)
include(CheckCXXSourceRuns)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()
string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

macro(CHECK_CXX_COMPILER_AND_LINKER_FLAGS _RESULT _CXX_FLAGS _LINKER_FLAGS)
  set(CMAKE_REQUIRED_FLAGS ${_CXX_FLAGS})
  set(CMAKE_REQUIRED_LIBRARIES ${_LINKER_FLAGS})
  set(CMAKE_REQUIRED_QUIET TRUE)
  check_cxx_source_runs("int main(int argc, char **argv) { return 0; }" ${_RESULT})
  set(CMAKE_REQUIRED_FLAGS "")
  set(CMAKE_REQUIRED_LIBRARIES "")
endmacro()

# GLFW: Build from sources in Windows, use system version in UNIX:
find_package(PkgConfig QUIET)

if (PKG_CONFIG_FOUND)
  pkg_search_module(GLFW glfw3)
endif()

if (GLFW_FOUND)
    message(STATUS "GLFW: System library found.")
    #include_directories(${GLFW_INCLUDE_DIRS})
    #target_link_libraries(simple ${GLFW_LIBRARIES})
else()
    message(STATUS "GLFW: No system library found, building from sources.")

    # Compile GLFW
    set(GLFW_BUILD_EXAMPLES OFF CACHE BOOL " " FORCE)
    set(GLFW_BUILD_TESTS OFF CACHE BOOL " " FORCE)
    set(GLFW_BUILD_DOCS OFF CACHE BOOL " " FORCE)
    set(GLFW_BUILD_INSTALL OFF CACHE BOOL " " FORCE)

    # Install required to export cmake targets
    set(GLFW_INSTALL OFF CACHE BOOL " " FORCE)

    set(GLFW_USE_CHDIR OFF CACHE BOOL " " FORCE)

    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        # Quench annoying deprecation warnings when compiling GLFW on OSX
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-deprecated-declarations")
    endif()

    # Set these variables for glfw, since we cannot control its target directly
    # for it being an external project:
    set(caod_backup ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY})
    set(crod_backup ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib/")
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/")

    add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/ext/glfw" "ext_build/glfw")
    # Two targets have now been defined: `glfw_objects`, which will be merged into
    # NanoGUI at the end, and `glfw`.  The `glfw` target is the library itself
    # (e.g., libglfw.so), but can be skipped as we do not need to link against it
    # (because we merge `glfw_objects` into NanoGUI).  Skipping is required for
    # XCode, but preferable for all build systems (reduces build artifacts).
    # JLBC 2020: This leads to runtime weird errors in MSVC: disabled.
    #set_target_properties(glfw PROPERTIES EXCLUDE_FROM_ALL 1 EXCLUDE_FROM_DEFAULT_BUILD 1)
    #set(OPTIONAL_GLFW_OBJECTS $<TARGET_OBJECTS:glfw_objects>)
    set(GLFW_LIBRARIES glfw)

    # undo changes of global variables:
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${caod_backup})
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${crod_backup})
    unset(caod_backup)
    unset(crod_backup)
endif()


if (MSVC)
  # Disable annoying MSVC warnings (all targets)
  add_definitions(/D "_CRT_SECURE_NO_WARNINGS")

  # Parallel build on MSVC (all targets)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")

  if (NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:SSE2")

    # Disable Eigen vectorization for Windows 32 bit builds (issues with unaligned access segfaults)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /DNANOGUI_EIGEN_DONT_ALIGN")
  endif()
endif()

# Compile with compiler warnings turned on
if(MSVC)
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  endif()
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
endif()

if (CMAKE_CXX_COMPILER_ID MATCHES "^(GNU|Clang|Intel)$")
  CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP14_FLAG)
  CHECK_CXX_COMPILER_FLAG("-std=c++11" HAS_CPP11_FLAG)

  if (HAS_CPP14_FLAG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
  elseif (HAS_CPP11_FLAG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  else()
    message(FATAL_ERROR "Unsupported compiler -- pybind11 requires C++11 support!")
  endif()
endif()

# Various optimizations for shared library release builds
if (NANOGUI_BUILD_SHARED)
  if (U_CMAKE_BUILD_TYPE MATCHES REL AND CMAKE_CXX_COMPILER_ID MATCHES "^(GNU|Clang)$")
    # Set the default symbol visibility to hidden
    if (NOT CMAKE_CXX_FLAGS MATCHES "-fvisibility")
      set(CMAKE_CXX_FLAGS "-fvisibility=hidden ${CMAKE_CXX_FLAGS}")
    endif()

    # Enable link time optimization
    if (NOT CMAKE_CXX_FLAGS MATCHES "-flto")
      if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        set(LTO_CXX_FLAGS "-flto=thin")
        set(LTO_LINKER_FLAGS "-flto=thin")
        if (NOT APPLE AND U_CMAKE_BUILD_TYPE MATCHES MINSIZEREL)
            # Clang Gold plugin does not support -Os
            set(LTO_CXX_FLAGS "${LTO_CXX_FLAGS} -O3")
        endif()
      else()
        set(LTO_CXX_FLAGS "-flto -fno-fat-lto-objects")
        set(LTO_LINKER_FLAGS "-flto")
      endif()

      CHECK_CXX_COMPILER_AND_LINKER_FLAGS(HAS_LTO ${LTO_CXX_FLAGS} ${LTO_LINKER_FLAGS})

      if (HAS_LTO)
        message(STATUS "NanoGUI: LTO support enabled.")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${LTO_LINKER_FLAGS}")
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${LTO_LINKER_FLAGS}")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${LTO_CXX_FLAGS}")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${LTO_CXX_FLAGS}")
      else()
        message(STATUS "NanoGUI: LTO not supported by the compiler.")
      endif()
    endif()
  elseif(MSVC)
    set(Configurations RELEASE RELWITHDEBINFO MINSIZEREL)
    set(LinkTypes EXE SHARED MODULE STATIC)
    foreach(Configuration ${Configurations})
      set("CMAKE_CXX_FLAGS_${Configuration}" "${CMAKE_CXX_FLAGS_${Configuration}} /GL")
      foreach(LinkType ${LinkTypes})
        set("CMAKE_${LinkType}_LINKER_FLAGS_${Configuration}" "${CMAKE_${LinkType}_LINKER_FLAGS_${Configuration}} /LTCG")
      endforeach()
    endforeach()
    message(STATUS "NanoGUI: LTO support enabled.")
  endif()
endif()

# Always use libc++ on Clang
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  CHECK_CXX_COMPILER_AND_LINKER_FLAGS(HAS_LIBCPP "-stdlib=libc++" "-stdlib=libc++")
  if (HAS_LIBCPP)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -stdlib=libc++")
    CHECK_CXX_COMPILER_AND_LINKER_FLAGS(HAS_LIBCPPABI "-stdlib=libc++" "-stdlib=libc++ -lc++abi")
    if(HAS_LIBCPPABI)
      set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lc++abi")
      set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lc++abi")
      message(STATUS "NanoGUI: using libc++ and libc++abi.")
    else()
      message(STATUS "NanoGUI: using libc++.")
    endif()
  else()
    message(STATUS "NanoGUI: NOT using libc++.")
  endif()
endif()

if (NANOGUI_USE_GLAD)
  # Build and include GLAD on Windows
  list(APPEND LIBNANOGUI_EXTRA_SOURCE
     "${CMAKE_CURRENT_SOURCE_DIR}/ext/glad/src/glad.c"
	 "${CMAKE_CURRENT_SOURCE_DIR}/ext/glad/include/glad/glad.h"
	 "${CMAKE_CURRENT_SOURCE_DIR}/ext/glad/include/KHR/khrplatform.h")
  if (MSVC)
    set_source_files_properties("${CMAKE_CURRENT_SOURCE_DIR}/ext/glad/src/glad.c"
      PROPERTIES COMPILE_FLAGS "/wd4055 ")
  endif()
endif()


if (${CMAKE_SYSTEM_NAME} MATCHES "BSD")
  include_directories(/usr/local/include)
  link_directories(/usr/local/lib)
  if(${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
    include_directories(/usr/X11R6/include/)
    link_directories(/usr/X11R6/lib)
  endif()
endif()

# Run simple cmake converter to put font files into the data segment

# Glob up resource files
file(GLOB resources "${CMAKE_CURRENT_SOURCE_DIR}/resources/*.ttf")

# Concatenate resource files into a comma separated string
string (REGEX REPLACE "([^\\]|^);" "\\1," resources_string "${resources}")
string (REGEX REPLACE "[\\](.)" "\\1" resources_string "${resources_string}")

# Create command line for running bin2c cmake script
set(bin2c_cmdline
  -DOUTPUT_C=nanogui_resources.cpp
  -DOUTPUT_H=nanogui_resources.h
  "-DINPUT_FILES=${resources_string}"
  -P "${CMAKE_CURRENT_SOURCE_DIR}/resources/bin2c.cmake")

# Run bin2c on resource files
add_custom_command(
  OUTPUT nanogui_resources.cpp nanogui_resources.h
  COMMAND ${CMAKE_COMMAND} ARGS ${bin2c_cmdline}
  DEPENDS ${resources}
  COMMENT "Running bin2c"
  PRE_BUILD VERBATIM)

# Needed to generated files
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# Set library type
if (NANOGUI_BUILD_SHARED)
  set(NANOGUI_LIBRARY_TYPE "SHARED")
else()
  set(NANOGUI_LIBRARY_TYPE "STATIC")
endif()

if (APPLE OR CMAKE_SYSTEM MATCHES "Linux")
  # Include coroutine support for running the mainloop in detached mode
  add_definitions(-DCORO_SJLJ)
  include_directories(ext/coro)
  list(APPEND LIBNANOGUI_PYTHON_EXTRA_SOURCE ext/coro/coro.c)
endif()

if (APPLE)
  # Use automatic reference counting for Objective-C portions
  add_compile_options(-fobjc-arc)
endif()

if (APPLE)
    list(APPEND LIBNANOGUI_EXTRA_SOURCE src/darwin.mm)
endif()

# For older cmake versions:
if(NOT MSVC AND NOT COMMAND target_link_options)
  #target_link_options(${PROJECT_NAME} PRIVATE -fPIC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fPIC")
endif()

# Compile main NanoGUI library
add_library(${PROJECT_NAME}  ${NANOGUI_LIBRARY_TYPE}
  # Merge NanoVG into the NanoGUI library
  ext/nanovg/src/nanovg.c
  # Merge GLAD into the NanoGUI library (only if needed)
  ${LIBNANOGUI_EXTRA_SOURCE}
  # Fonts etc.
  nanogui_resources.cpp
  include/nanogui/glutil.h src/glutil.cpp
  include/nanogui/common.h src/common.cpp
  include/nanogui/widget.h src/widget.cpp
  include/nanogui/theme.h src/theme.cpp
  include/nanogui/layout.h src/layout.cpp
  include/nanogui/screen.h src/screen.cpp
  include/nanogui/label.h src/label.cpp
  include/nanogui/window.h src/window.cpp
  include/nanogui/popup.h src/popup.cpp
  include/nanogui/checkbox.h src/checkbox.cpp
  include/nanogui/button.h src/button.cpp
  include/nanogui/popupbutton.h src/popupbutton.cpp
  include/nanogui/combobox.h src/combobox.cpp

=== apps/2d-slam-demo/CMakeLists.txt ===
#-----------------------------------------------------------------
# CMake file for the MRPT application:  2d-slam-demo
#
#  Run with "cmake ." at the root directory
#
#  October 2007, Jose Luis Blanco <jlblanco@ctima.uma.es>
#-----------------------------------------------------------------
project(2d-slam-demo)

mrpt_return_if_not_wxwidgets()

# ---------------------------------------------
# TARGET:
# ---------------------------------------------
set(SRCS
	slamdemoApp.cpp   slamdemoApp.h
	slamdemoMain.cpp  slamdemoMain.h
	batch_experiments.cpp
	CDlgParams.cpp CDlgParams.h
	CLogView.cpp CLogView.h
	)

if(WIN32)
	set(SRCS ${SRCS} resource.rc)
endif()

# Define the executable target:
add_executable(${PROJECT_NAME} WIN32 ${SRCS} ${MRPT_VERSION_RC_FILE})

# Add the required libraries for linking:
target_link_libraries(${PROJECT_NAME} imp_wxwidgets)

# Dependencies on MRPT libraries:
#  Just mention the top-level dependency, the rest will be detected automatically,
#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
DeclareAppDependencies(${PROJECT_NAME}
	mrpt::gui
	mrpt::slam
	mrpt::tclap
	)

DeclareAppForInstall(${PROJECT_NAME})

AppStartMenuLink(${PROJECT_NAME} "2D KF-SLAM Simulator")   # Add link to the Start menu (in Windows Installable packages)

=== apps/RawLogViewer/CMakeLists.txt ===
#-----------------------------------------------------------------
# CMake file for the MRPT application:  RawLogViewer
#
#  Run with "cmake ." at the root directory
#
#  October 2007, Jose Luis Blanco <jlblanco@ctima.uma.es>
#-----------------------------------------------------------------
project(RawLogViewer)

mrpt_return_if_not_wxwidgets()
if (NOT CMAKE_MRPT_HAS_OPENGL_GLUT)
	return()
endif()

# ---------------------------------------------
# TARGET:
# ---------------------------------------------
set(SRCS
 CFormEdit.cpp	CFormEdit.h
 CFormMotionModel.cpp	CFormMotionModel.h
 CFormPlayVideo.cpp		CFormPlayVideo.h
 CFormRawMap.cpp		CFormRawMap.h
 CScanMatching.cpp		CScanMatching.h
 CFormChangeSensorPositions.cpp CFormChangeSensorPositions.h
 COdometryParams.cpp 		COdometryParams.h
 CScanAnimation.cpp			CScanAnimation.h
 xRawLogViewerApp.cpp	xRawLogViewerApp.h
 xRawLogViewerMain.cpp	xRawLogViewerMain.h
 MyGLCanvas.cpp         MyGLCanvas.h
 main_gps_ops.cpp
 main_images_ops.cpp
 main_imports_exports.cpp
 main_artwork.cpp
 main_convert_ops.cpp
 main_show_selected_object.cpp
 CRawlogTreeView.cpp	CRawlogTreeView.h
 CFormBatchSensorPose.cpp  CFormBatchSensorPose.h
 CIniEditor.cpp 		CIniEditor.h
 )

if(WIN32)
    set(SRCS ${SRCS} resource.rc)
endif()

# Define the executable target:
add_executable(${PROJECT_NAME} WIN32 ${SRCS} ${MRPT_VERSION_RC_FILE})

# Add the required libraries for linking:
target_link_libraries(${PROJECT_NAME} imp_wxwidgets mrptwxthings)

# Dependencies on MRPT libraries:
#  Just mention the top-level dependency, the rest will be detected automatically,
#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
DeclareAppDependencies(${PROJECT_NAME} mrpt::slam mrpt::gui mrpt::topography)
DeclareAppForInstall(${PROJECT_NAME})
AppStartMenuLink(${PROJECT_NAME} "RawLog (dataset) viewer")   # Add link to the Start menu (in Windows Installable packages)

=== debian/changelog ===
mrpt (1:2.1.7-2) unstable; urgency=medium

  * Fix broken Debian dependencies for libmrpt-vision-lgpl (Closes: #986071).

 -- José Luis Blanco Claraco <joseluisblancoc@gmail.com>  Tue, 13 Apr 2021 02:09:00 +0200

mrpt (1:2.1.7-1) unstable; urgency=medium

  * Fix FTBFS: reference to ‘Tracker’ is ambiguous (Closes: #978209).
  * New version of upstream sources.

 -- José Luis Blanco Claraco <joseluisblancoc@gmail.com>  Sat, 02 Jan 2021 06:46:41 +0100

=== debian/control ===
Source: mrpt
Section: science
Priority: optional
Maintainer: José Luis Blanco Claraco <joseluisblancoc@gmail.com>
Build-Depends: debhelper (>= 12),
	debhelper-compat (= 12),
	cmake,
	perl,
	zlib1g-dev,
	libjpeg-dev,
	libwxgtk3.0-gtk3-dev,
	libftdi1-dev,
	freeglut3-dev,
	libopencv-dev,
	libavcodec-dev, libavformat-dev, libavutil-dev, libswscale-dev,
	doxygen,
	ghostscript,
	graphviz,
	texlive, latexmk, texlive-latex-extra, texlive-science,
	doxygen-latex,
	libdc1394-dev [linux-any] | libdc1394-22-dev [linux-any],
	libusb-1.0-0-dev [linux-any],
	libudev-dev [linux-any],
	libfreenect-dev,
	libpcap-dev,
	libopenni2-dev,
	libsuitesparse-dev,
	libeigen3-dev,
	libassimp-dev,
	qtbase5-dev,
	liboctomap-dev,
	libqt5opengl5-dev,
	libjsoncpp-dev,
	libtinyxml2-dev,
	libcv-bridge-dev,
	libgeometry-msgs-dev,
	libnav-msgs-dev,
	librosbag-storage-dev,
	libroscpp-dev,
	libsensor-msgs-dev,
	libstd-srvs-dev,
	libstereo-msgs-dev,
	libtf2-dev,
	libtf2-msgs-dev,
	libglu1-mesa-dev,
	libglfw3-dev,
	libxxf86vm-dev,
	libxrandr-dev,
	libsimpleini-dev,
	libicu-dev
Standards-Version: 4.5.1
Homepage: https://www.mrpt.org/

Package: mrpt-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
	libjs-jquery
Description: Mobile Robot Programming Toolkit - Documentation and examples
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 The libraries include classes for easily managing 3D(6D) geometry,
 probability density functions (pdfs) over many predefined variables (points
 and poses, landmarks, maps), Bayesian inference (Kalman filters, particle
 filters), image processing, path planning and obstacle avoidance, 3D
 visualization of all kind of maps (points, occupancy grids, landmarks,...),
 Graph-SLAM, Bundle Adjustment, etc.
 Gathering, manipulating and inspecting very large robotic datasets (Rawlogs)
 efficiently is another goal of MRPT, supported by several classes and
 applications.
 .
 The MRPT is free software and is released under the BSD-new.
 .
 This package provides the documentation and examples of MRPT, and the book
  Writing Scientific Applications with the Mobile Robot Programming Toolkit
  in .ps.gz format.

Package: libmrpt-bayes2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - bayes library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-bayes-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-bayes2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-math-dev, libmrpt-config-dev
Description: Mobile Robot Programming Toolkit - bayes development package
 This package provides headers and libraries for development.

Package: libmrpt-comms2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - comms library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-comms-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-comms2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-io-dev
Description: Mobile Robot Programming Toolkit - comms development package
 This package provides headers and libraries for development.

Package: libmrpt-config2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - config library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-config-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-config2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-core-dev,libmrpt-system-dev,libmrpt-expr-dev
Description: Mobile Robot Programming Toolkit - config development package
 This package provides headers and libraries for development.

Package: libmrpt-containers2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - containers library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-containers-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-containers2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-core-dev
Description: Mobile Robot Programming Toolkit - containers development package
 This package provides headers and libraries for development.

Package: libmrpt-core2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - core library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-core-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-core2.1 (= ${binary:Version}),
         libmrpt-common-dev
Description: Mobile Robot Programming Toolkit - core development package
 This package provides headers and libraries for development.

Package: libmrpt-detectors2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - detectors library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-detectors-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-detectors2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-gui-dev,libmrpt-slam-dev
Description: Mobile Robot Programming Toolkit - detectors development package
 This package provides headers and libraries for development.

Package: libmrpt-expr2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - expr library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-expr-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-expr2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-core-dev
Description: Mobile Robot Programming Toolkit - expr development package
 This package provides headers and libraries for development.

Package: libmrpt-graphs2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - graphs library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-graphs-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-graphs2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-opengl-dev,libmrpt-poses-dev
Description: Mobile Robot Programming Toolkit - graphs development package
 This package provides headers and libraries for development.

Package: libmrpt-graphslam2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - graphslam library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-graphslam-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-graphslam2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-gui-dev,libmrpt-slam-dev
Description: Mobile Robot Programming Toolkit - graphslam development package
 This package provides headers and libraries for development.

Package: libmrpt-gui2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - gui library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-nanogui2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - nanogui library
 A custom version of the nanogui library.

Package: libmrpt-gui-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-gui2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-opengl-dev, libmrpt-nanogui-dev
Description: Mobile Robot Programming Toolkit - gui development package
 This package provides headers and libraries for development.

Package: libmrpt-nanogui-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-nanogui2.1 (= ${binary:Version}),
         libglfw3-dev
Description: Mobile Robot Programming Toolkit - nanogui development package
 This package provides headers and libraries for development.

Package: libmrpt-hmtslam2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - hmtslam library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-hmtslam-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-hmtslam2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-graphslam-dev
Description: Mobile Robot Programming Toolkit - hmtslam development package
 This package provides headers and libraries for development.

Package: libmrpt-hwdrivers2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - hwdrivers library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-hwdrivers-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-hwdrivers2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-comms-dev, libmrpt-gui-dev,
         libmrpt-maps-dev, libmrpt-vision-dev
Description: Mobile Robot Programming Toolkit - hwdrivers development package
 This package provides headers and libraries for development.

Package: libmrpt-img2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - img library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-img-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-img2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-io-dev, libmrpt-math-dev,
         libmrpt-config-dev
Description: Mobile Robot Programming Toolkit - img development package
 This package provides headers and libraries for development.

Package: libmrpt-io2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Mobile Robot Programming Toolkit - io library
 More about MRPT libraries in: https://www.mrpt.org/Libraries

Package: libmrpt-io-dev
Section: libdevel
Architecture: any
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-io2.1 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-system-dev
Description: Mobile Robot Programming Toolkit - io development package
 This package provides headers and libraries for development.

Package: libmrpt-kinematics2.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Makefile for MRPT Debian package.

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all,+fortify

# default: dont build expensive caller graphs with dot in the documentation pkg
export MRPT_genCALLERGRAPHS=NO

# For multiarch support:
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_TARGET_MULTIARCH ?= $(shell dpkg-architecture -qDEB_TARGET_MULTIARCH)
#DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

# SSE options
ifeq ($(DEB_HOST_ARCH),amd64)
CMAKE_ARCH_FLAGS = -DMRPT_AUTODETECT_SIMD=OFF -DENABLE_SSE2=ON -DENABLE_SSE3=ON
else
CMAKE_ARCH_FLAGS = -DMRPT_AUTODETECT_SIMD=OFF
endif

# Unit tests can be run with target "test_legacy", or "test_gdb", which shows stack
# traces on failure:
MRPT_TEST_TARGET = test_legacy

# Debug info from the cmake scripts
export VERBOSE = 1

# Avoid running out of memory on mipsel,mips64el
ifneq (,$(findstring mips,$(DEB_HOST_ARCH)))
  export DEB_CXXFLAGS_MAINT_APPEND += -g1
endif

CMAKE_FLAGS = \
	-DCMAKE_INSTALL_PREFIX="$(CURDIR)/debian/usr/" \
	-DCMAKE_INSTALL_LIBDIR="lib/$(DEB_TARGET_MULTIARCH)" \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_BUILD_TYPE=Release  \
	-DMRPT_ALLOW_LGPLV3=ON \
	-DCMAKE_MRPT_USE_DEB_POSTFIXS="1" \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DDISABLE_BFD=ON \
	$(CMAKE_ARCH_FLAGS) \
	

# Don't set: CMAKE_SKIP_RPATH=ON --> it makes unit tests to fail,
# and the rpath is removed anyway by cmake's install target.

%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean -O--buildsystem=cmake
	# Clean possible leftover from a former build:
	rm -fr debian/usr
	find doc/graphslam-engine-guide/ -maxdepth 1  -type f ! -name '*.tex' ! -name 'Makefile' -delete

override_dh_auto_build-arch:
	dh_auto_build -O--buildsystem=cmake

	# Python bindings:
#	dh_python3 --package=python3-mrpt


override_dh_auto_build-indep:
	# Build doc targets:
	dh_auto_build -O--buildsystem=cmake -- \
		man_pages_all \
		documentation_psgz_guides

	# clean useless doxygen files:
	find $(CURDIR)/doc/ -name '*.md5' | xargs -I FIL rm FIL

override_dh_auto_configure:
	# Show CPU flags, to help debugging unit test crashes related to
	# illegal instructions, etc.
	cat /proc/cpuinfo
	# Show env vars for debugging:
	env
	# Autoconfigure step:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_install:
	# Do nothing?
	echo "[override_dh_auto_install]"

override_dh_auto_test-indep:
	echo "[override_dh_auto_test-indep] Do nothing."

override_dh_auto_test-arch:
	# Tests for arch-dependent :
	echo "[override_dh_auto_test-arch]"
	dh_auto_build -O--buildsystem=cmake -- $(MRPT_TEST_TARGET) -j1

override_dh_install:
	# Install:
	dh_auto_build -O--buildsystem=cmake -- install

	# Move all the ".so.x.y" files to the corresponding binary packages:
	# libmrpt-${name}${CMAKE_MRPT_VERSION_NUMBER_MAJOR}.${CMAKE_MRPT_VERSION_NUMBER_MINOR}/usr/...
	VERSION=$$(head version_prefix.txt -n1 | cut -f 1-2 -d . ); tmpfil=$$(mktemp); find $(CURDIR)/debian/ -name "*.so.?.*" > $$tmpfil; cat $$tmpfil | while read line; do f=$$(basename $$line | cut -f 1 -d '.'); echo "Processing so file: $$line, basename: $$f"; dir=$(CURDIR)/debian/$$f$${VERSION}/usr/lib/$(DEB_TARGET_MULTIARCH); mkdir -p $$dir; mv -f $$line $$dir; done

	# JLBC Nov 2018: Due to what is explained in MRPT/cmakemodules/DeclareMRPTLibs.cmake, we need to make some "mv" here:

	# Move all the ".so" files to the proper place: the -dev package:
	tmpfil=$$(mktemp); find $(CURDIR)/debian/ -name "*.so" | grep -v 'dev' | grep -v 'pymrpt' > $$tmpfil; cat $$tmpfil | while read line; do f=$$(basename $$line .so); echo "Processing so file: $$line, basename: $f"; mkdir -p $(CURDIR)/debian/$$f-dev/usr/lib/$(DEB_TARGET_MULTIARCH); mv -vf $$line $(CURDIR)/debian/$$f-dev/usr/lib/$(DEB_TARGET_MULTIARCH); done

	# Move cmake modules to the -dev packages:
	tmpfil=$$(mktemp); find $(CURDIR)/debian/usr/share/ -name '*-config.cmake' > $$tmpfil; cat $$tmpfil | while read line; do f=$$(dirname $$line); f=$$(basename $$f); echo "Processing cmake scripts: $$line, module name: $$f"; dir=$(CURDIR)/debian/lib$$f-dev/usr/share/; mkdir -p $$dir; mv -f $(CURDIR)/debian/usr/share/$$f $$dir; done

	# Move headers to -dev directories:
	cp -vr $(CURDIR)/debian/usr/libmrpt-*dev $(CURDIR)/debian/

	# Move python stuff:
#	mkdir -p $(CURDIR)/debian/python-mrpt/usr/lib
#	mv -v $(CURDIR)/debian/usr/lib/* $(CURDIR)/debian/python-mrpt/usr/lib

	# Move mrpt-doc:
	dir=$(CURDIR)/debian/mrpt-doc/usr/share/doc/mrpt-doc; mkdir -p $$dir; mv -v $(CURDIR)/debian/usr/mrpt-doc/usr/share/doc/mrpt-doc/* $$dir

	# Move mrpt-apps:
	dir=$(CURDIR)/debian/mrpt-apps/usr/; mkdir -p $$dir; cp -vr $(CURDIR)/debian/usr/mrpt-apps/* $$dir/..

	# Move mrpt-common:
	dir=$(CURDIR)/debian/mrpt-common/usr/; mkdir -p $$dir; cp -vr $(CURDIR)/debian/usr/mrpt-common/* $$dir/..

override_dh_missing:
	dh_missing --list-missing

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/$/.asc/" \
  https://github.com/mrpt/mrpt/releases  .*/mrpt-(\d\S*)\.tar\.gz
